
' Balloon Race by Kristopher Windsor
' Klik of the Month, April 17th, 2010

#include once "fbgfx.bi"

Const sx = 800, sy = 600
Const balloon_max = 12, background_sx = 1600
Const balloon_sx = 160, balloon_sy = 171, balloon_height = 198, balloon_box_size = 32, gfx_max = 5
Const basket_sx = 32, basket_sy = 25
Const trophy_sx = 246, trophy_sy = 306

Type balloon_type
  As Double x, y, xv, yv
  As Integer ytarget 'ai only
  As fb.image Ptr sprite
End Type

Dim Shared As Integer fc, background_offset, balloon_total, place
Dim Shared As fb.image Ptr gfx(0 To gfx_max), background, basket, trophy
Dim Shared As balloon_type balloon(1 To balloon_max)

Screenres sx, sy, 32,, fb.GFX_ALPHA_PRIMITIVES
Randomize()

background = imagecreate(background_sx, sy)
Bload "background.bmp", background
For i As Integer = 0 To gfx_max
  gfx(i) = imagecreate(balloon_sx, balloon_sy)
  Bload "b" & i & ".bmp", gfx(i)
Next i
basket = imagecreate(basket_sx, basket_sy)
Bload "basket.bmp", basket
trophy = imagecreate(trophy_sx, trophy_sy)
Bload "trophy.bmp", trophy

balloon_total = balloon_max
For i As Integer = 0 To balloon_total - 1
  With balloon(i + 1)
    .x = i * balloon_sx
    .y = sy - balloon_height
    .ytarget = Int(Rnd() * sy)
    .sprite = Iif(i = 0, gfx(0), gfx(Int(Rnd() * gfx_max) + 1))
  End With
Next i

Do
  fc += 1
  background_offset = -balloon(1).x * .3 - background_sx
  While background_offset < -background_sx
    background_offset += background_sx
  Wend
  
  'player control
  With balloon(1)
    .yv = .yv * .95 + (Multikey(fb.sc_up) - Multikey(fb.sc_down)) * .5
  End With
  
  'ai control
  For i As Integer = 2 To balloon_total
    With balloon(i)
      If Rnd() < .01 Then .ytarget = Int(Rnd() * sy)
      .yv *= .95
      If .y < .ytarget Then .yv += .5 Else .yv -= .5
    End With
  Next i
  
  'wind and bounce
  place = 1
  For i As Integer = 1 To balloon_total
    With balloon(i)
      .xv = .xv * .95 + Abs(Sin(.x / 1000 + .y / 100)) * .1
      .x += .xv
      .y += .yv
      
      For j As Integer = 1 To i - 1
        var hit = @balloon(j)
        If .x + balloon_sx < hit->x Then Continue For
        If .x > hit->x + balloon_sx Then Continue For
        If .y + balloon_sy < hit->y Then Continue For
        If .y > hit->y + balloon_sy Then Continue For
        .xv += 5 * Sgn(.x - hit->x)
        hit->xv += 5 * Sgn(hit->x - .x)
      Next j
      
      If .y < -balloon_height \ 2 Then .y = -balloon_height \ 2
      If .y + balloon_height \ 2 > sy Then .y = sy - balloon_height \ 2
      
      If .x > balloon(1).x Then place += 1
    End With
  Next i
  
  'display
  Screenlock()
  Put (background_offset, 0), background, alpha, 60
  Put (background_offset + background_sx, 0), background, alpha, 60
  
  For i As Integer = 0 To sy - 1 Step 2
    Line (0, i) - Step(Abs(Sin(balloon(1).x / 1000 + (i - balloon_sy \ 2) / 100)) * 32, 0), &H55FFFFFF
  Next i
  
  For i As Integer = 1 To balloon_total
    With balloon(i)
      var x = .x - balloon(1).x + 100
      var x2 = x + Cos(.x / 10) * 1.5
      Put (x, .y), .sprite, trans
      Line (x + balloon_sx \ 2, .y + balloon_sy) - (x2 + balloon_sx \ 2, .y + balloon_height - basket_sy), &HFF000000
      Put (x2 + (balloon_sx - balloon_box_size) \ 2, .y + balloon_height - basket_sy), basket, trans
    End With
  Next i
  
  Draw String (2, 2), "Place: " & place & " / " & balloon_max & " Time: " & Cint(fc / 60), &HFFFFFFFF
  Screenunlock()
  
  Sleep(5, 1)
Loop Until Inkey() = Chr(27) Or place = 1

If place = 1 Then
  Put ((sx - trophy_sx) \ 2, (sy - trophy_sy) \ 2), trophy, trans
  Draw String (sx \ 2 - 56, sy * .4), "YOU'RE WINNER!", &HFF000000
  Sleep(2000, 1)
  While Len(Inkey()): Wend
  Sleep()
End If

imagedestroy(background)
For i As Integer = 0 To gfx_max
  imagedestroy(gfx(i))
Next i
imagedestroy(basket)
imagedestroy(trophy)
